<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2015 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| IP Autoban
| Version 1.5
| Filename: autoban_admin.php
| Author: Pisatel
| Support: http://www.meweb.ru/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

    require_once "../../maincore.php";
    if (!checkrights("IAB") || !defined("iAUTH") || !isset($_GET['aid']) || $_GET['aid'] != iAUTH) { redirect("../../index.php"); }

    require_once THEMES."templates/admin_header.php";
    include INFUSIONS."autoban_panel/infusion_db.php";
    include INFUSIONS."autoban_panel/locale/".(file_exists(INFUSIONS."autoban_panel/locale/".$settings['locale'].".php") ? $settings['locale'] : "Russian").".php";
    $nav = "<table class='tbl-border' style='border-spacing:0; margin:0 auto 20px auto; width:400px; text-align:center;'>\n<tr>\n";
     $nav .= "<td class='".(!isset($_GET['page']) ? "tbl2" : "tbl1")."'><a href='".FUSION_SELF.$aidlink."'>".$locale['all_settings']."</a></td>\n";
    $nav .= iSUPERADMIN ? "<td class='".(isset($_GET['page']) && $_GET['page'] == "htaccess" ? "tbl2" : "tbl1")."'><a href='".FUSION_SELF.$aidlink."&amp;page=htaccess'>".$locale['ht_settings']."</a></td>\n" : "";
    $nav .= "<td class='".(isset($_GET['page']) && $_GET['page'] == "banlist" ? "tbl2" : "tbl1")."'><a href='".FUSION_SELF.$aidlink."&amp;page=banlist'>".$locale['ban_settings']."</a></td>\n";
    $nav .= "</tr>\n</table>\n";

    $table_empty = "<tr>\n<td style='text-align:center' class='tbl2'>".$locale['table_empty']."</td>\n</tr>\n";
//banlist
    if (isset($_GET['page']) && $_GET['page'] != "htaccess" && $_GET['page'] == "banlist") {
    if (isset($_GET['status']) && !isset($message)) {
    if ($_GET['status'] == "delonban") {
    $message = $locale['ban_delonban'];
  } elseif ($_GET['status'] == "delban") {
    $message = $locale['ban_deleted'];
}
    if ($message) { echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
} elseif ((isset($_GET['action']) && $_GET['action'] == "deleteban")) {
    $result = dbquery("DELETE FROM ".DB_BLACK_LIST_IP);
    redirect(FUSION_SELF.$aidlink."&amp;page=banlist&amp;status=delban");
 } elseif ((isset($_GET['action']) && $_GET['action'] == "delonban" && isset($_GET['ban_id']) && isnum($_GET['ban_id']))) {
    $result = dbquery("DELETE FROM ".DB_BLACK_LIST_IP." WHERE ban_id='".$_GET['ban_id']."' LIMIT 1");
    redirect(FUSION_SELF.$aidlink."&amp;page=banlist&amp;status=delonban");
}
    $bl = opentable($locale['ban_table']);
    $rows = dbcount("(ban_id)", DB_BLACK_LIST_IP);
    if (!isset($_GET['rowstart']) || !isnum($_GET['rowstart'])) { $_GET['rowstart'] = 0; }
    $i = 0;
    $result = dbquery("SELECT ban_id, INET_NTOA(ban_ip) AS ban_ip, ban_datestamp FROM ".DB_BLACK_LIST_IP." ORDER BY ban_id DESC LIMIT ".$_GET['rowstart'].",100");
    $bl .= "<table class='tbl-border' style='border-spacing:0; margin:0 auto 20px auto; width:100%; text-align:center;'>\n";
    if (!dbrows($result)){
    $bl .= $table_empty;
} else {
    $bl .= "<tr>\n";
    $bl .= "<td class='tbl2 tbl-border' style='width:47%; text-align:center; vertical-align:middle;'><strong>".$locale['ban_date']."</strong></td>\n";
    $bl .= "<td class='tbl2 tbl-border' style='width:47%; text-align:center; vertical-align:middle;'><strong>".$locale['ban_ip']."</strong></td>\n";
    $bl .= "<td class='tbl2 tbl-border' style='text-align:center; vertical-align:middle;'><strong>".$locale['ban_del_this']."</strong></td>\n";
    $bl .= "</tr>\n";
    while ($data = dbarray($result)){
    $bl .= "<tr class='".($i % 2 == 0 ? "tbl1" : "tbl2")."'>\n";
    $bl .= "<td style='width:47%; text-align:center; vertical-align:middle;'>".showdate("%d %b %Y %T", $data['ban_datestamp'])."</td>\n";
    $bl .= "<td style='width:47%;  vertical-align:middle;'>".$data['ban_ip']."</td>\n";
    $bl .= "<td style='text-align:center; vertical-align:middle;'><a href='".FUSION_SELF.$aidlink."&amp;page=banlist&amp;action=delonban&amp;ban_id=".$data['ban_id']."' onclick=\"return confirm('".$locale['ban_warning_delthis']."');\">".$locale['ban_delthis']."</a></td>\n";
    $bl .= "</tr>\n";
    $i++;
}
    $bl .= "<tr>\n<td class='tbl2' colspan='3' style='text-align:right;'>\n";
    $bl .= "<a class='button' href='".FUSION_SELF.$aidlink."&amp;page=banlist&amp;action=deleteban' onclick=\"return confirm('".$locale['ban_warning_delete']."');\">".$locale['ban_delete']."</a>\n</td>\n";
    $bl .= "</tr>\n";
}
    $bl .= "</table>\n";
    if ($rows > 100) {
    $bl .= "<div style='text-align:center; margin:5px auto;'>\n".makePageNav($_GET['rowstart'],100,$rows,3,FUSION_SELF.$aidlink."&amp;")."\n</div>\n";
}
    $bl .= closetable();
    echo $nav.$bl;
}
//htaccess
    elseif (isset($_GET['page']) && $_GET['page'] != "banlist" && $_GET['page'] == "htaccess"){
    if (iSUPERADMIN){
    if (isset($_GET['status']) && !isset($message)) {
    if ($_GET['status'] == "suht") {
    $message = $locale['ht412'];
} elseif ($_GET['status'] == "seht") {
    $message = $locale['ht413']."<br />\n";
    switch ($_GET['error']) {
    case 1:
    $message .= "<span class='small'>".$locale['ht414']."</span>";
    break;
    case 2:
    $message .= "<span class='small'>".$locale['ht415']."</span>";
    break;
 }
}
   if ($message) { echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
}

    if (isset($_POST['save_htaccess']) && (iSUPERADMIN)) {
    $error = 0;
    $file = BASEDIR.".htaccess";
    $htaccess_content = $_POST['htaccess_content'];
    if (!is_writable($file)) {
    $error = 1;
 }
    if ($error == 0) {
    if(openFile($file, "WRITE", stripslash($htaccess_content))) {
    redirect(FUSION_SELF.$aidlink."&amp;page=htaccess&amp;status=suht");
} else {
    redirect(FUSION_SELF.$aidlink."&amp;page=htaccess&amp;status=seht&amp;error=2");
 }
} else {
    redirect(FUSION_SELF.$aidlink."&amp;page=htaccess&amp;status=seht&amp;error=".$error);
 }
}

    if (isset($_POST['set_default'])) {
    $error = 0;
    $file = BASEDIR.".htaccess";
    $htaccess_content = "#ErrorDocument 404 /404.php\n";
    $htaccess_content .= "#ErrorDocument 403 /403.php\n";
    $htaccess_content .= "#Options -Indexes\n";
    if (!is_writable($file)) {
    $error = 1;
 }
    if ($error == 0) {
    if(openFile($file, "WRITE", $htaccess_content)) {
    redirect(FUSION_SELF.$aidlink."&amp;page=htaccess&amp;status=suht");
} else {
    redirect(FUSION_SELF.$aidlink."&amp;page=htaccess&amp;status=seht&amp;error=3");
 }
} else {
    redirect(FUSION_SELF.$aidlink."&amp;page=htaccess&amp;status=seht&amp;error=".$error);
 }
}
    $bh = opentable($locale['ht400']);
    if (file_exists(BASEDIR.".htaccess")) {
    $file = BASEDIR.".htaccess";
    $bh .= "<form name='inputform' method='post' action='".FUSION_SELF.$aidlink."&amp;page=htaccess'>\n";
    $bh .= "<table class='tbl-border center' style='border-spacing:0; width:460px;'>\n";
    $bh .= "<tr>\n";
 echo "<td class='tbl2' style='text-align:center;font-weight:bold; padding:1px'>".$locale['ht420']."</td>\n";
    $bh .= "</tr>\n<tr>\n";
    $bh .= "<td class='tbl1' style='text-align:center; padding:1px'>";
    $bh .= "<textarea name='htaccess_content' class='textbox' rows='20' cols='40' style='width:100%;'>".openFile($file, "READ")."</textarea>";
    $bh .= "</td>\n";
    $bh .= "</tr>\n<tr>\n";
    $bh .= "<td class='tbl1' style='text-align:center; padding:1px'>";
    $bh .= "<input type='submit' name='save_htaccess' class='button' value='".$locale['ht422']."' />\n";
    $bh .= "<input type='submit' name='set_default' class='button' value='".$locale['ht423']."' onclick=\"return confirm('".$locale['ht410']."');\" />\n";
    $bh .= "</td>\n";
    $bh .= "</tr>\n";
    $bh .= "</table>\n";
    $bh .= "</form>\n";
} else {
    $bh .= "<div class='admin-message'>".$locale['ht411']."</div>\n";
}
    $bh .= closetable();
    echo $nav.$bh;
} else {
    redirect(FUSION_SELF.$aidlink);

 }
} else {
//visit ip
    if (isset($_GET['status']) && !isset($message)) {
    if ($_GET['status'] == "del") {
    $message = $locale['all_deleted'];
 }
    if ($message) { echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; }
} elseif (isset($_GET['action']) && $_GET['action'] == "delete") {
    $result = dbquery("DELETE FROM ".DB_ALL_VISITS);
    redirect(FUSION_SELF.$aidlink."&status=del");
}
    $ba = opentable($locale['all_table']);
    $rows = dbcount("(visit_id)", DB_ALL_VISITS);
    if (!isset($_GET['rowstart']) || !isnum($_GET['rowstart'])) { $_GET['rowstart'] = 0; }
    $i = 0;
    $result = dbquery("SELECT INET_NTOA(visit_ip) AS visit_ip, visit_datestamp FROM ".DB_ALL_VISITS."  ORDER BY visit_id DESC LIMIT ".$_GET['rowstart'].",100");
    $ba .= "<table class='tbl-border' style='border-spacing:0; margin:0 auto 20px auto; width:100%; text-align:center;'>\n";
  if (!dbrows($result)){
    $ba .= $table_empty;
} else {
    $ba .= "<tr>\n";
    $ba .= "<td class='tbl2 tbl-border' style='width:50%; text-align:center; vertical-align:middle;'><strong>".$locale['all_date']."</strong></td>\n";
    $ba .= "<td class='tbl2 tbl-border' style='width:50%; text-align:center; vertical-align:middle;'><strong>".$locale['all_ip']."</strong></td>\n";
    $ba .= "</tr>\n";
    while ($data = dbarray($result)) {
    $ba .= "<tr class='".($i % 2 == 0 ? "tbl1" : "tbl2")."'>\n";
    $ba .= "<td style='width:50%; text-align:center; vertical-align:middle;'>".showdate("%d %b %Y %T", $data['visit_datestamp'])."</td>\n";
    $ba .= "<td style='width:50%; vertical-align:middle;'>".$data['visit_ip']."</td>\n";
    $ba .= "</tr>\n";
  $i++;
}
    $ba .= "<tr><td class='tbl2' colspan='2' style='text-align:right;'>\n";
    $tablesize = dbquery("SHOW TABLE STATUS LIKE '".DB_ALL_VISITS."'");
    $item = dbarray($tablesize);
    $sum = $item['Data_length'] + $item['Index_length'];
    $ba .= $locale['tablesize']."<strong>".parsebytesize($sum)."</strong> &nbsp; <a class='button' href='".FUSION_SELF.$aidlink."&amp;action=delete' onclick=\"return confirm('".$locale['all_warning_delete']."');\">".$locale['all_delete']."</a>\n</td>\n";
    $ba .= "</tr>\n";
}
    $ba .= "</table>\n";
    if ($rows > 100){
    $ba .= "<div style='text-align:center; margin:5px auto;'>\n".makePageNav($_GET['rowstart'],100,$rows,3,FUSION_SELF.$aidlink."&amp;")."\n</div>\n";
}
    $ba .= closetable();
    echo $nav.$ba;
}
    require_once THEMES."templates/footer.php";

?>